from gtk import *
from rox import support
from rox.Toolbar import Toolbar
import sys, os, string

class LabelWindow (GtkWindow):
    def __init__ (self):
        GtkWindow.__init__ (self)
	self.set_title ('LabelGenerator')

        vbox = GtkVBox ()
        self.add (vbox)

        toolbar = Toolbar ()
        vbox.pack_start (toolbar, expand=FALSE, fill=TRUE)

        box, self.category = self.createLabel ('Category')
        vbox.pack_start (box, expand=FALSE, fill=TRUE)

        box, self.subcategory = self.createLabel ('Subcategory')
        vbox.pack_start (box, expand=FALSE, fill=TRUE)

        contentsbox = GtkVBox ()
        contentsbox.pack_start (GtkLabel ("Contents"), expand=FALSE,
                                fill=TRUE)
        self.contents = GtkText (None)
        self.contents.set_editable (TRUE)
        contentsbox.pack_start (self.contents, expand=TRUE, fill=TRUE)
        vbox.pack_start (contentsbox, expand=TRUE, fill=TRUE)

        icon_dir = support.app_dir + '/icons/'
        close = toolbar.add_button ('Close', icon_dir + 'Close.xpm',
                                    'Close this window')
        printer = toolbar.add_button ('Print', icon_dir + 'Print.xpm',
                                      'Print this label')
        stomper = toolbar.add_button ('Stomp', icon_dir + 'Stomper.xpm',
                                      'Print this label for a CD Stomper')
        close.connect ('clicked', self.close)
        printer.connect ('clicked', self.printLabel)
        stomper.connect ('clicked', self.printStomperLabel)

        support.rox_toplevel_ref ()
        self.connect ('destroy', self.destroyed)
        self.connect ('delete-event', self.delete_event)
        self.category.grab_focus ()
        self.show_all ()

    def createLabel (self, label):
        box = GtkHBox ()
        box.pack_start (GtkLabel (label + ":"), expand=FALSE, fill=TRUE)
        entry = GtkEntry ()
        box.pack_start (entry, expand=TRUE, fill=TRUE)
        box.set_border_width (5)
        box.set_spacing (5)
        return box, entry

    def printLabel (self, button):
        category = self.category.get_text ()
        subcategory = self.subcategory.get_text ()
        contents = self.contents.get_chars (0, -1)
        pid = os.fork ()
        if pid == 0:                    # child
            read, write = os.pipe ()
            pid = os.fork ()
            if pid == 0:                # pid generating output
                os.close (read)
                os.dup2 (write, 1)
                items = string.split (contents, "\n")
                argument = string.join (items, "%")
                os.execvp ("cdlabelgen", ("cdlabelgen",
                                          "-c", category,
                                          "-s", subcategory,
                                          "-i" + argument))
                raise RuntimeError, "exec failed!"
            else:                       # pid execing lpr
                os.close (write)
                os.dup2 (read, 0)
                os.execvp ("lpr", ("lpr",))
        else:
            os.waitpid (pid, 0)

    def printStomperLabel (self, button):
        category = self.category.get_text ()
        subcategory = self.subcategory.get_text ()
        template = open (support.app_dir + '/stomper.ps')
        out = os.popen ("lpr", "w")
        out.write (template.readline ()) # write %!PS line
        out.write ("/title (%s) def" % category)
        out.write ("/subtitle (%s) def" % subcategory)
        out.write (template.read ())
        out.close ()
    def close (self, button):
        self.destroy ()
    def destroyed (self, window):
        support.rox_toplevel_unref ()
    def delete_event (self, window, event):
        return 0
